Index: trunk/MagicSoft/Mars/macros/calibration.C
===================================================================
--- trunk/MagicSoft/Mars/macros/calibration.C	(revision 4609)
+++ trunk/MagicSoft/Mars/macros/calibration.C	(revision 4662)
@@ -87,14 +87,14 @@
 
 static TString outpath = "./";
-static TString inpath  = "/home/rootdata/Calib/2004_05_24/";
+static TString inpath  = "/home/rootdata/Calib/2004_06_22/";
 static TString badfile = "";
 //
 // the default pedestal run for the calibration
 //
-static const Int_t   pedrun  = 26569;
+static const Int_t   pedrun  = 30749;
 //
 // the default start calibration run 
 //
-static const Int_t   calrun1 = 26568;
+static const Int_t   calrun1 = 30752;
 //
 // the default last calibration run (if 0, only one run is taken, otherwise consecutive runs 
@@ -110,5 +110,4 @@
 //
 static Bool_t blindpix = kTRUE;
-//
 // A switch to use the PIN Diode 
 //
@@ -139,5 +138,6 @@
   //  MExtractFixedWindowPeakSearch extractor;
   //  MExtractSlidingWindow  extractor;   
-  MExtractFixedWindowSpline extractor;
+  //  MExtractFixedWindowSpline extractor;
+  MExtractFixedWindow extractor;
   //  MExtractAmplitudeSpline extractor;
   //  MExtractTimeAndChargeSpline extractor;
@@ -145,5 +145,5 @@
   // Set Ranges or Windows
   //
-  extractor.SetRange(1,14,2,13);
+  extractor.SetRange(3,14,4,13);
   //  extractor.SetWindows(8,8);
 
@@ -204,5 +204,8 @@
   pedloop.SetOutputPath(outpath.Data());
   if (useDisplay)
-    pedloop.SetDisplay(display);
+    {
+      pedloop.SetDisplay(display);
+      pedloop.SetDataCheckDisplay();
+    }
   pedloop.SetBadPixels(badcam);
 
@@ -226,5 +229,5 @@
   // 
   // For everything, you have ever dreamed of, choose:
-  //  calloop.SetFullDisplay();
+  // calloop.SetFullDisplay();
 
   //
@@ -275,4 +278,7 @@
       MJExtractCalibTest testloop;
       
+      // If you want to see the data-check plots only, choose:
+      testloop.SetDataCheckDisplay();
+
       testloop.SetExtractor(&extractor);
       testloop.SetTimeExtractor(&timeext);
@@ -290,21 +296,4 @@
       return 4;
       
-      gLog << endl;
-      gLog << "Mean equiv. number of photons from cascades per mm^2 Inner pixels: " 
-       << testloop.GetTestCam().GetMeanMeanPhotPerArea(0) 
-           << " +- " << testloop.GetTestCam().GetRmsMeanPhotPerArea(0) << endl;
-      gLog << "Sigma equiv. number of photons from cascades per mm^2 Inner pixels: " 
-           << testloop.GetTestCam().GetMeanSigmaPhotPerArea(0) 
-           << " +- " << testloop.GetTestCam().GetRmsSigmaPhotPerArea(0) << endl;
-      
-      gLog << endl;
-      gLog << "Mean equiv. number of photons from cascades per mm^2 Outer pixels: " 
-           << testloop.GetTestCam().GetMeanMeanPhotPerArea(1) 
-           << " +- " << testloop.GetTestCam().GetRmsMeanPhotPerArea(1) << endl;
-      gLog << "Sigma equiv. number of photons from cascades per mm^2 Outer pixels: " 
-           << testloop.GetTestCam().GetMeanSigmaPhotPerArea(1) 
-           << " +- " << testloop.GetTestCam().GetRmsSigmaPhotPerArea(1) << endl;
-      gLog << endl;  
-      
     }
   
@@ -344,30 +333,6 @@
   MCalibrationQECam     &qecam       = calloop.GetCalibrationCam();
   MBadPixelsCam         &badcam      = calloop.GetBadPixels();
-  MHCalibrationTestCam  &testcam     = testloop.GetTestCam();
+  MCalibrationTestCam   &testcam     = testloop.GetTestCam();
   MHCalibrationTestTimeCam &testtime = testloop.GetTestTimeCam();
-*/
-
-  //
-  // List of interesting plots:
-  // 
-/*
-  testcam[200].DrawClone("fourierevents");
-  testcam.GetAverageHiGainArea(0).DrawClone();
-  testcam.GetAverageLoGainArea(0).DrawClone();
-  testcam.GetAverageHiGainArea(1).DrawClone();
-  testcam.GetAverageLoGainArea(1).DrawClone();
-
-  testcam.GetAverageHiGainSector(1).DrawClone();
-  testcam.GetAverageLoGainSector(1).DrawClone();
-  testcam.GetAverageHiGainSector(2).DrawClone();
-  testcam.GetAverageLoGainSector(2).DrawClone();
-  testcam.GetAverageHiGainSector(3).DrawClone();
-  testcam.GetAverageLoGainSector(3).DrawClone();
-  testcam.GetAverageHiGainSector(4).DrawClone();
-  testcam.GetAverageLoGainSector(4).DrawClone();
-  testcam.GetAverageHiGainSector(5).DrawClone();
-  testcam.GetAverageLoGainSector(5).DrawClone();
-  testcam.GetAverageHiGainSector(6).DrawClone();
-  testcam.GetAverageLoGainSector(6).DrawClone();
 */
 