Index: trunk/MagicSoft/Mars/mjobs/JobsLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/JobsLinkDef.h	(revision 4756)
+++ trunk/MagicSoft/Mars/mjobs/JobsLinkDef.h	(revision 4758)
@@ -8,4 +8,5 @@
 #pragma link C++ class MSequence+;
 
+#pragma link C++ class MJStar+;
 #pragma link C++ class MJPedestal+;
 #pragma link C++ class MJCalibration+;
Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 4756)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 4758)
@@ -48,5 +48,4 @@
 #include "MEvtLoop.h"
 
-#include "MJPedestal.h"
 #include "MStatusDisplay.h"
 
@@ -58,5 +57,5 @@
 #include "MCalibrationRelTimeCam.h"
 
-#include "MReadMarsFile.h"
+#include "MReadReports.h"
 #include "MGeomApply.h"
 #include "MPedCalcFromLoGain.h"
@@ -193,5 +192,6 @@
     //    return kFALSE;
 
-    CheckEnv();
+    if (fEnv)
+        CheckEnv();
 
     // --------------------------------------------------------------------------------
@@ -266,6 +266,13 @@
     plist.AddToList(&tlist);
 
-    MReadMarsFile read("Events");
-    read.DisableAutoScheme();
+    //MReadMarsFile read("Events");
+    //read.DisableAutoScheme();
+    MReadReports read;
+    read.AddTree("Events", "MTime.", kTRUE);
+    read.AddTree("Trigger");
+    read.AddTree("Camera");
+    read.AddTree("Drive");
+    read.AddTree("CC");
+    read.AddTree("Currents");
     read.AddFiles(iter);
     //read.AddFiles(fnamein);
@@ -305,31 +312,67 @@
 
     MWriteRootFile write(2, Form("%s{s/_D_/_Y_}", fPathOut.Data()), fOverwrite);
-    write.AddContainer("MCerPhotEvt",    "Events");
-    write.AddContainer("MPedPhotCam",    "Events");
-    write.AddContainer("MTime",          "Events");
-    write.AddContainer("MRawEvtHeader",  "Events");
-    write.AddContainer("MArrivalTime",   "Events");
-    write.AddContainer("MRawRunHeader",  "RunHeaders");
-    write.AddContainer("MBadPixelsCam",  "RunHeaders");
-    write.AddContainer("MGeomCam",       "RunHeaders");
-
+    // Run Header
+    write.AddContainer("MRawRunHeader",       "RunHeaders");
+    write.AddContainer("MBadPixelsCam",       "RunHeaders");
+    write.AddContainer("MGeomCam",            "RunHeaders");
+    // Monte Carlo Headers
+    write.AddContainer("MMcTrigHeader",       "RunHeaders", kFALSE);
+    write.AddContainer("MMcConfigRunHeader",  "RunHeaders", kFALSE);
+    write.AddContainer("MMcCorsikaRunHeader", "RunHeaders", kFALSE);
+    // Monte Carlo
+    write.AddContainer("MMcEvt",              "Events", kFALSE);
+    write.AddContainer("MMcTrig",             "Events", kFALSE);
+    // Data
+    write.AddContainer("MCerPhotEvt",         "Events");
+    write.AddContainer("MPedPhotCam",         "Events");
+    write.AddContainer("MTime",               "Events");
+    write.AddContainer("MRawEvtHeader",       "Events");
+    write.AddContainer("MArrivalTime",        "Events");
+    // Slow-Control: Current
+    write.AddContainer("MTimeCurrents",       "Currents", kFALSE);
+    write.AddContainer("MCameraDC",           "Currents", kFALSE);
+    write.AddContainer("MReportCurrents",     "Currents", kFALSE);
+    // Slow-Control: Camera
+    write.AddContainer("MReportCamera",       "Camera", kFALSE);
+    write.AddContainer("MTimeCamera",         "Camera", kFALSE);
+    write.AddContainer("MCameraAUX",          "Camera", kFALSE);
+    write.AddContainer("MCameraCalibration",  "Camera", kFALSE);
+    write.AddContainer("MCameraCooling",      "Camera", kFALSE);
+    write.AddContainer("MCameraHV",           "Camera", kFALSE);
+    write.AddContainer("MCameraLV",           "Camera", kFALSE);
+    write.AddContainer("MCameraLids",         "Camera", kFALSE);
+    // Slow-Control: Trigger
+    write.AddContainer("MReportTrigger",      "Trigger", kFALSE);
+    write.AddContainer("MTimeTrigger",        "Trigger", kFALSE);
+    // Slow-Control: Drive
+    write.AddContainer("MReportDrive",        "Drive", kFALSE);
+    write.AddContainer("MTimeDrive",          "Drive", kFALSE);
+    // Slow-Control: Central Control
+    write.AddContainer("MReportCC",           "CC", kFALSE);
+    write.AddContainer("MTimeCC",             "CC", kFALSE);
+
+    // Now setup tasklist for events
+    MTaskList tlist2;
+    tlist2.AddToList(&apply);
+    tlist2.AddToList(&merge);
+    tlist2.AddToList(&pedlo);
+    tlist2.AddToList(&fill0);
+    if (extractor1)
+        tlist2.AddToList(&taskenv1);
+    if (extractor2)
+        tlist2.AddToList(&taskenv2);
+    tlist2.AddToList(&fill1);
+    tlist2.AddToList(&calib);
+    tlist2.AddToList(&caltm);
+    tlist2.AddToList(&fill2);
+    tlist2.AddToList(&bpcal);
+    tlist2.AddToList(&treat);
+    tlist2.AddToList(&fill3);
+    tlist2.AddToList(&fill4);
+    tlist2.AddToList(&fill5);
+
+    // Now setup main tasklist
     tlist.AddToList(&read);
-    tlist.AddToList(&apply);
-    tlist.AddToList(&merge);
-    tlist.AddToList(&pedlo);
-    tlist.AddToList(&fill0);
-    if (extractor1)
-        tlist.AddToList(&taskenv1);
-    if (extractor2)
-        tlist.AddToList(&taskenv2);
-    tlist.AddToList(&fill1);
-    tlist.AddToList(&calib);
-    tlist.AddToList(&caltm);
-    tlist.AddToList(&fill2);
-    tlist.AddToList(&bpcal);
-    tlist.AddToList(&treat);
-    tlist.AddToList(&fill3);
-    tlist.AddToList(&fill4);
-    tlist.AddToList(&fill5);
+    tlist.AddToList(&tlist2, "Events");
     tlist.AddToList(&write);
 
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4756)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4758)
@@ -1389,5 +1389,6 @@
     //    return kFALSE;
 
-    CheckEnv();
+    if (fEnv)
+        CheckEnv();
 
     // --------------------------------------------------------------------------------
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 4756)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 4758)
@@ -536,5 +536,6 @@
     //    return kFALSE;
 
-    CheckEnv();
+    if (fEnv)
+        CheckEnv();
 
     // --------------------------------------------------------------------------------